diff --git a/src/modules/Subtitles/SRT.cpp b/src/modules/Subtitles/SRT.cpp
index 96ee9459..fe209c7f 100644
--- a/src/modules/Subtitles/SRT.cpp
+++ b/src/modules/Subtitles/SRT.cpp
@@ -20,7 +20,7 @@
 #include <Functions.hpp>
 #include <LibASS.hpp>
 
-#include <QRegularExpression>
+#include <QRegExp>
 #include <QStringList>
 
 #include <cstdio>
@@ -33,7 +33,7 @@ bool SRT::toASS(const QByteArray &srt, LibASS *ass, double)
     bool ok = false;
     const char *scanfFmt = (srt.left(11 /* Including BOM */).contains("WEBVTT")) ? "%d:%d:%d.%d" : "%d:%d:%d,%d";
 
-    for (const QString &entry : QString(QString("\n\n") + srt).remove('\r').split(QRegularExpression("\n\n+(\\d+\n)?"), Qt::SkipEmptyParts))
+    for (const QString &entry : QString(QString("\n\n") + srt).remove('\r').split(QRegExp("\\n\\n+(\\d+\\n)?"), QString::SkipEmptyParts))
     {
         int idx = entry.indexOf('\n');
         if (idx > -1)
diff --git a/src/modules/Subtitles/SRT.hpp b/src/modules/Subtitles/SRT.hpp
index 946054b0..c8e74374 100644
--- a/src/modules/Subtitles/SRT.hpp
+++ b/src/modules/Subtitles/SRT.hpp
@@ -20,9 +20,9 @@
 
 #include <SubsDec.hpp>
 
-class SRT final : public SubsDec
+class SRT : public SubsDec
 {
-    bool toASS(const QByteArray &, class LibASS *, double) override;
+    bool toASS(const QByteArray &, class LibASS *, double);
 };
 
 #define SRTSubsName "SRT Subtitles"
diff --git a/src/modules/Subtitles/Subtitles.hpp b/src/modules/Subtitles/Subtitles.hpp
index a9ca6e0f..d3a9555a 100644
--- a/src/modules/Subtitles/Subtitles.hpp
+++ b/src/modules/Subtitles/Subtitles.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class Subtitles final : public Module
+class Subtitles : public Module
 {
 public:
     Subtitles();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -38,13 +38,13 @@ private:
 class QCheckBox;
 class QDoubleSpinBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *srtEB, *classicEB, *mEB;
     QDoubleSpinBox *maxLenB;
diff --git a/src/modules/VideoFilters/BlendDeint.hpp b/src/modules/VideoFilters/BlendDeint.hpp
index e084f691..4ad47e1e 100644
--- a/src/modules/VideoFilters/BlendDeint.hpp
+++ b/src/modules/VideoFilters/BlendDeint.hpp
@@ -20,14 +20,14 @@
 
 #include <VideoFilter.hpp>
 
-class BlendDeint final : public VideoFilter
+class BlendDeint : public VideoFilter
 {
 public:
     BlendDeint();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 };
 
 #define BlendDeintName "Blend"
diff --git a/src/modules/VideoFilters/BobDeint.hpp b/src/modules/VideoFilters/BobDeint.hpp
index 0ee037e9..bc875259 100644
--- a/src/modules/VideoFilters/BobDeint.hpp
+++ b/src/modules/VideoFilters/BobDeint.hpp
@@ -20,14 +20,14 @@
 
 #include <VideoFilter.hpp>
 
-class BobDeint final : public VideoFilter
+class BobDeint : public VideoFilter
 {
 public:
     BobDeint();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 };
 
 #define BobDeintName "Bob"
diff --git a/src/modules/VideoFilters/DiscardDeint.hpp b/src/modules/VideoFilters/DiscardDeint.hpp
index af767d71..a00ebf29 100644
--- a/src/modules/VideoFilters/DiscardDeint.hpp
+++ b/src/modules/VideoFilters/DiscardDeint.hpp
@@ -20,14 +20,14 @@
 
 #include <VideoFilter.hpp>
 
-class DiscardDeint final : public VideoFilter
+class DiscardDeint : public VideoFilter
 {
 public:
     DiscardDeint();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 };
 
 #define DiscardDeintName "Discard"
diff --git a/src/modules/VideoFilters/FPSDoubler.cpp b/src/modules/VideoFilters/FPSDoubler.cpp
index fedf45d9..e43ae02e 100644
--- a/src/modules/VideoFilters/FPSDoubler.cpp
+++ b/src/modules/VideoFilters/FPSDoubler.cpp
@@ -20,6 +20,8 @@
 
 #include <QDebug>
 
+#include <cmath>
+
 FPSDoubler::FPSDoubler(Module &module, bool &fullScreen)
     : VideoFilter(false)
     , m_fullScreen(fullScreen)
@@ -48,7 +50,7 @@ bool FPSDoubler::filter(QQueue<Frame> &framesQueue)
         auto frame = m_internalQueue.dequeue();
         framesQueue.enqueue(frame);
         const auto frameTs = frame.ts();
-        if (!qIsNaN(m_lastTS))
+        if (!std::isnan(m_lastTS))
         {
             m_frameTimeSum += frameTs - m_lastTS;
             ++m_frames;
@@ -76,7 +78,7 @@ bool FPSDoubler::processParams(bool *)
     m_frameTimeSum = 0.0;
     m_frames = 0;
 
-    m_lastTS = qQNaN();
+    m_lastTS = std::numeric_limits<double>::quiet_NaN();
 
     return true;
 }
diff --git a/src/modules/VideoFilters/FPSDoubler.hpp b/src/modules/VideoFilters/FPSDoubler.hpp
index 204ba261..616deb45 100644
--- a/src/modules/VideoFilters/FPSDoubler.hpp
+++ b/src/modules/VideoFilters/FPSDoubler.hpp
@@ -20,17 +20,17 @@
 
 #include <VideoFilter.hpp>
 
-class FPSDoubler final : public VideoFilter
+class FPSDoubler : public VideoFilter
 {
 public:
     FPSDoubler(Module &module, bool &fullScreen);
     ~FPSDoubler();
 
-    bool set() override;
+    bool set();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 
 private:
     bool &m_fullScreen;
diff --git a/src/modules/VideoFilters/MotionBlur.hpp b/src/modules/VideoFilters/MotionBlur.hpp
index a45d1968..957bdc06 100644
--- a/src/modules/VideoFilters/MotionBlur.hpp
+++ b/src/modules/VideoFilters/MotionBlur.hpp
@@ -20,14 +20,14 @@
 
 #include <VideoFilter.hpp>
 
-class MotionBlur final : public VideoFilter
+class MotionBlur : public VideoFilter
 {
 public:
     MotionBlur();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 };
 
 #define MotionBlurName "Motion Blur"
diff --git a/src/modules/VideoFilters/VFilters.cpp b/src/modules/VideoFilters/VFilters.cpp
index 9657955b..c1cb875e 100644
--- a/src/modules/VideoFilters/VFilters.cpp
+++ b/src/modules/VideoFilters/VFilters.cpp
@@ -35,10 +35,15 @@ VFilters::VFilters() :
     init("FPSDoubler/MaxFPS", 29.990);
     init("FPSDoubler/OnlyFullScreen", true);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(&QMPlay2Core, &QMPlay2CoreClass::fullScreenChanged,
             this, [this](bool fs) {
         m_fullScreen = fs;
     });
+#else
+    connect(&QMPlay2Core, SIGNAL(fullScreenChanged(bool)),
+            this, SLOT(onFullScreenChanged(bool)));
+#endif
 }
 
 QList<VFilters::Info> VFilters::getModulesInfo(const bool) const
diff --git a/src/modules/VideoFilters/VFilters.hpp b/src/modules/VideoFilters/VFilters.hpp
index 62f69315..25914ee4 100644
--- a/src/modules/VideoFilters/VFilters.hpp
+++ b/src/modules/VideoFilters/VFilters.hpp
@@ -22,16 +22,20 @@
 
 #include <QCoreApplication>
 
-class VFilters final : public Module
+class VFilters : public Module
 {
-    Q_DECLARE_TR_FUNCTIONS(VFilters)
+    Q_OBJECT
 public:
     VFilters();
+private slots:
+#if QT_VERSION < 0x050000 || defined(Q_MOC_RUN)
+    void onFullScreenChanged(bool fs) { m_fullScreen = fs; }
+#endif
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
 private:
     bool m_fullScreen = false;
@@ -42,7 +46,7 @@ private:
 class QDoubleSpinBox;
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 
@@ -50,7 +54,7 @@ public:
     ModuleSettingsWidget(Module &module);
 
 private:
-    void saveSettings() override;
+    void saveSettings();
 
 private:
     QDoubleSpinBox *const m_minFpsSpinBox;
diff --git a/src/modules/VideoFilters/YadifDeint.cpp b/src/modules/VideoFilters/YadifDeint.cpp
index b5ff29df..6c6ef7a0 100644
--- a/src/modules/VideoFilters/YadifDeint.cpp
+++ b/src/modules/VideoFilters/YadifDeint.cpp
@@ -25,7 +25,11 @@
 
 #include <QMPlay2Core.hpp>
 
-#include <QtConcurrent/QtConcurrentRun>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QtConcurrent/QtConcurrentRun>
+#else
+    #include <QtCore/QtCore>
+#endif
 
 #include <algorithm>
 #include <vector>
@@ -266,6 +270,7 @@ bool YadifDeint::filter(QQueue<Frame> &framesQueue)
 
         const int threadsCount = min(m_threadsPool.maxThreadCount(), destFrame.height(1));
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         vector<QFuture<void>> threads;
         threads.reserve(threadsCount);
 
@@ -275,6 +280,11 @@ bool YadifDeint::filter(QQueue<Frame> &framesQueue)
 
         for (auto &&thread : threads)
             thread.waitForFinished();
+#else
+        // Qt4: Run sequentially without QtConcurrent
+        for (int i = 0; i < threadsCount; ++i)
+            doFilter(i, threadsCount);
+#endif
 
         if (m_doubler)
             deinterlaceDoublerCommon(destFrame);
diff --git a/src/modules/VideoFilters/YadifDeint.hpp b/src/modules/VideoFilters/YadifDeint.hpp
index 45fff197..85bd437b 100644
--- a/src/modules/VideoFilters/YadifDeint.hpp
+++ b/src/modules/VideoFilters/YadifDeint.hpp
@@ -22,14 +22,14 @@
 
 #include <QThreadPool>
 
-class YadifDeint final : public VideoFilter
+class YadifDeint : public VideoFilter
 {
 public:
     YadifDeint(bool m_doubler, bool m_spatialCheck);
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 private:
     const bool m_doubler;
     const bool m_spatialCheck;
diff --git a/src/modules/Visualizations/FFTSpectrum.hpp b/src/modules/Visualizations/FFTSpectrum.hpp
index bafe21e8..2513b0aa 100644
--- a/src/modules/Visualizations/FFTSpectrum.hpp
+++ b/src/modules/Visualizations/FFTSpectrum.hpp
@@ -27,19 +27,19 @@
 
 class FFTSpectrum;
 
-class FFTSpectrumW final : public VisWidget
+class FFTSpectrumW : public VisWidget
 {
     friend class FFTSpectrum;
     Q_DECLARE_TR_FUNCTIONS(FFTSpectrumW)
 public:
     FFTSpectrumW(FFTSpectrum &);
 private:
-    void paint(QPainter &p) override;
+    void paint(QPainter &p);
 
-    void mouseMoveEvent(QMouseEvent *e) override;
+    void mouseMoveEvent(QMouseEvent *e);
 
-    void start() override;
-    void stop() override;
+    void start();
+    void stop();
 
     QVector<float> spectrumData;
     QVector<QPair<qreal, QPair<qreal, double>>> lastData;
@@ -54,22 +54,22 @@ private:
 
 /**/
 
-class FFTSpectrum final : public QMPlay2Extensions
+class FFTSpectrum : public QMPlay2Extensions
 {
 public:
     FFTSpectrum(Module &);
 
     void soundBuffer(const bool);
 
-    bool set() override;
+    bool set();
 private:
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    bool isVisualization() const override;
-    void connectDoubleClick(const QObject *, const char *) override;
-    void visState(bool, uchar, uint) override;
-    void sendSoundData(const QByteArray &) override;
-    void clearSoundData() override;
+    bool isVisualization() const;
+    void connectDoubleClick(const QObject *, const char *);
+    void visState(bool, uchar, uint);
+    void sendSoundData(const QByteArray &);
+    void clearSoundData();
 
     /**/
 
diff --git a/src/modules/Visualizations/SimpleVis.hpp b/src/modules/Visualizations/SimpleVis.hpp
index b4688732..e959ecf8 100644
--- a/src/modules/Visualizations/SimpleVis.hpp
+++ b/src/modules/Visualizations/SimpleVis.hpp
@@ -26,7 +26,7 @@
 
 class SimpleVis;
 
-class SimpleVisW final : public VisWidget
+class SimpleVisW : public VisWidget
 {
     friend class SimpleVis;
 
@@ -34,12 +34,12 @@ class SimpleVisW final : public VisWidget
 public:
     SimpleVisW(SimpleVis &);
 private:
-    void paint(QPainter &p) override;
+    void paint(QPainter &p);
 
-    void resizeEvent(QResizeEvent *) override;
+    void resizeEvent(QResizeEvent *);
 
-    void start() override;
-    void stop() override;
+    void start();
+    void stop();
 
     QByteArray soundData;
     quint8 chn;
@@ -54,22 +54,22 @@ private:
 
 /**/
 
-class SimpleVis final : public QMPlay2Extensions
+class SimpleVis : public QMPlay2Extensions
 {
 public:
     SimpleVis(Module &);
 
     void soundBuffer(const bool);
 
-    bool set() override;
+    bool set();
 private:
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    bool isVisualization() const override;
-    void connectDoubleClick(const QObject *, const char *) override;
-    void visState(bool, uchar, uint) override;
-    void sendSoundData(const QByteArray &) override;
-    void clearSoundData() override;
+    bool isVisualization() const;
+    void connectDoubleClick(const QObject *, const char *);
+    void visState(bool, uchar, uint);
+    void sendSoundData(const QByteArray &);
+    void clearSoundData();
 
     /**/
 
diff --git a/src/modules/Visualizations/VisWidget.cpp b/src/modules/Visualizations/VisWidget.cpp
index c956435f..6de153f0 100644
--- a/src/modules/Visualizations/VisWidget.cpp
+++ b/src/modules/Visualizations/VisWidget.cpp
@@ -21,7 +21,7 @@
 #include <DockWidget.hpp>
 #include <Functions.hpp>
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QMouseEvent>
 #include <QPainter>
 #include <QMenu>
@@ -58,7 +58,8 @@ VisWidget::VisWidget()
 
     connect(&tim, SIGNAL(timeout()), this, SLOT(updateVisualization()));
     connect(dw, SIGNAL(dockVisibilityChanged(bool)), this, SLOT(visibilityChanged(bool)));
-    connect(&QMPlay2Core, qOverload<const QPixmap &>(&QMPlay2CoreClass::wallpaperChanged), this, &VisWidget::wallpaperChanged);
+    // Qt4: Use SIGNAL/SLOT syntax instead of function pointers
+    connect(&QMPlay2Core, SIGNAL(wallpaperChanged(const QPixmap &)), this, SLOT(wallpaperChanged(const QPixmap &)));
     connect(this, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(contextMenu(const QPoint &)));
 }
 
@@ -82,7 +83,7 @@ void VisWidget::setUseOpenGL(bool b)
     m_pendingUpdate = false;
     if (b && !glW)
     {
-        glW = new QOpenGLWidget(this);
+        glW = new QGLWidget(this);
         glW->setAttribute(Qt::WA_TransparentForMouseEvents);
         glW->setContextMenuPolicy(Qt::NoContextMenu);
         glW->setFocusPolicy(Qt::NoFocus);
@@ -156,8 +157,7 @@ bool VisWidget::eventFilter(QObject *watched, QEvent *event)
     if (glW && watched == glW && event->type() == QEvent::Paint)
     {
         QPainter p(glW);
-        if (QGuiApplication::platformName().contains("wayland"))
-            p.fillRect(rect(), Qt::black);
+        // Qt4: No Wayland support, skip this check
         paint(p);
         m_pendingUpdate = false;
         return true;
diff --git a/src/modules/Visualizations/VisWidget.hpp b/src/modules/Visualizations/VisWidget.hpp
index c709a0d3..ec9cf362 100644
--- a/src/modules/Visualizations/VisWidget.hpp
+++ b/src/modules/Visualizations/VisWidget.hpp
@@ -22,7 +22,7 @@
 #include <QTimer>
 
 #ifdef USE_OPENGL
-#   include <QOpenGLWidget>
+#   include <QtOpenGL/QGLWidget>
 #endif
 
 class DockWidget;
@@ -45,7 +45,7 @@ protected:
 
     void setUseOpenGL(bool b);
 
-    void resizeEvent(QResizeEvent *e) override;
+    void resizeEvent(QResizeEvent *e);
 
     QTimer tim;
     bool stopped;
@@ -60,7 +60,7 @@ private:
     bool eventFilter(QObject *watched, QEvent *event) override final;
 
 #ifdef USE_OPENGL
-    QOpenGLWidget *glW = nullptr;
+    QGLWidget *glW = nullptr;
     bool m_pendingUpdate = false;
 #endif
     bool dockWidgetVisible = false;
diff --git a/src/modules/Visualizations/Visualizations.cpp b/src/modules/Visualizations/Visualizations.cpp
index b4f35226..3257d208 100644
--- a/src/modules/Visualizations/Visualizations.cpp
+++ b/src/modules/Visualizations/Visualizations.cpp
@@ -140,5 +140,5 @@ void ModuleSettingsWidget::saveSettings()
     sets().set("SimpleVis/SoundLength", sndLenB->value());
     sets().set("FFTSpectrum/Size", fftSizeB->value());
     sets().set("FFTSpectrum/LinearScale", m_fftLinearScaleB->isChecked());
-    sets().set("FFTSpectrum/LimitFreq", m_fftLimitFreqB->currentData().toInt());
+    sets().set("FFTSpectrum/LimitFreq", m_fftLimitFreqB->itemData(m_fftLimitFreqB->currentIndex()).toInt());
 }
diff --git a/src/modules/Visualizations/Visualizations.hpp b/src/modules/Visualizations/Visualizations.hpp
index b4150d35..00287dea 100644
--- a/src/modules/Visualizations/Visualizations.hpp
+++ b/src/modules/Visualizations/Visualizations.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class Visualizations final : public Module
+class Visualizations : public Module
 {
 public:
     Visualizations();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -39,13 +39,13 @@ class QCheckBox;
 class QComboBox;
 class QSpinBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QSpinBox *refTimeB = nullptr, *sndLenB, *fftSizeB;
     QComboBox *m_fftLimitFreqB;
diff --git a/src/modules/XVideo/XVideo.cpp b/src/modules/XVideo/XVideo.cpp
index cfd84296..7d5c50ba 100644
--- a/src/modules/XVideo/XVideo.cpp
+++ b/src/modules/XVideo/XVideo.cpp
@@ -19,8 +19,6 @@
 #include <XVideo.hpp>
 #include <XVideoWriter.hpp>
 
-#include <QGuiApplication>
-
 XVideo::XVideo() :
     Module("XVideo")
 {
@@ -33,14 +31,24 @@ XVideo::XVideo() :
 QList<XVideo::Info> XVideo::getModulesInfo(const bool showDisabled) const
 {
     QList<Info> modulesInfo;
-    if (showDisabled || (QGuiApplication::platformName() == "xcb" && getBool("Enabled")))
+    // Qt4: Use Q_WS_X11 instead of platformName check
+#ifdef Q_WS_X11
+    if (showDisabled || getBool("Enabled"))
         modulesInfo += Info(XVideoWriterName, WRITER, QStringList{"video"});
+#else
+    Q_UNUSED(showDisabled)
+#endif
     return modulesInfo;
 }
 void *XVideo::createInstance(const QString &name)
 {
-    if (name == XVideoWriterName && QGuiApplication::platformName() == "xcb" && getBool("Enabled"))
+    // Qt4: Use Q_WS_X11 instead of platformName check
+#ifdef Q_WS_X11
+    if (name == XVideoWriterName && getBool("Enabled"))
         return new XVideoWriter(*this);
+#else
+    Q_UNUSED(name)
+#endif
     return nullptr;
 }
 
diff --git a/src/modules/XVideo/XVideo.hpp b/src/modules/XVideo/XVideo.hpp
index a85c1eaa..fb03aebf 100644
--- a/src/modules/XVideo/XVideo.hpp
+++ b/src/modules/XVideo/XVideo.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class XVideo final : public Module
+class XVideo : public Module
 {
 public:
     XVideo();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -38,13 +38,13 @@ private:
 class QCheckBox;
 class QComboBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *enabledB, *useSHMB;
     QComboBox *adaptorsB;
diff --git a/src/modules/XVideo/XVideoWriter.hpp b/src/modules/XVideo/XVideoWriter.hpp
index d5a6fb02..38bfb9e3 100644
--- a/src/modules/XVideo/XVideoWriter.hpp
+++ b/src/modules/XVideo/XVideoWriter.hpp
@@ -24,18 +24,18 @@
 
 #include <QWidget>
 
-class Drawable final : public QWidget
+class Drawable : public QWidget
 {
     friend class XVideoWriter;
 public:
     Drawable(class XVideoWriter &);
     ~Drawable() final = default;
 private:
-    void resizeEvent(QResizeEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void resizeEvent(QResizeEvent *);
+    void paintEvent(QPaintEvent *);
+    bool event(QEvent *);
 
-    QPaintEngine *paintEngine() const override;
+    QPaintEngine *paintEngine() const;
 
     int X, Y, W, H;
     QRect dstRect, srcRect;
@@ -46,7 +46,7 @@ private:
 
 class QMPlay2OSD;
 
-class XVideoWriter final : public VideoWriter
+class XVideoWriter : public VideoWriter
 {
     friend class Drawable;
 public:
@@ -54,16 +54,16 @@ public:
 private:
     ~XVideoWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList) override;
+    bool processParams(bool *paramsCorrected);
+    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList);
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/qmplay2/CMakeLists.txt b/src/qmplay2/CMakeLists.txt
index 2d3a5aef..7eacdcba 100644
--- a/src/qmplay2/CMakeLists.txt
+++ b/src/qmplay2/CMakeLists.txt
@@ -125,18 +125,10 @@ if(USE_OPENGL)
         opengl/opengl.qrc
     )
 
-    if(BUILD_WITH_QT6)
-        list(APPEND OPENGL_LIBS Qt6::OpenGL Qt6::OpenGLWidgets)
-        get_target_property(QtGui_Enabled_Features Qt6::Gui QT_ENABLED_PUBLIC_FEATURES)
-    endif()
-
-    if((${QT_PREFIX}Gui_OPENGL_IMPLEMENTATION STREQUAL GLESv2) OR (QtGui_Enabled_Features MATCHES "opengles"))
-        if(NOT WIN32)
-            list(APPEND OPENGL_LIBS GLESv2)
-        endif()
-    elseif(${QT_PREFIX}Gui_OPENGL_IMPLEMENTATION STREQUAL GLES)
-        message(SEND_ERROR "OpenGL|ES 1.0 is not supported!")
-    endif()
+    # Qt4 has OpenGL support built into QtOpenGL (already linked via QT_USE_FILE)
+    # For macOS 10.6.8, we use OpenGL 2.0
+    find_package(OpenGL REQUIRED)
+    list(APPEND OPENGL_LIBS ${OPENGL_LIBRARIES})
 endif()
 
 if(USE_VULKAN)
@@ -220,11 +212,8 @@ endif()
 if(USE_FREEDESKTOP_NOTIFICATIONS)
     list(APPEND QMPLAY2_HDR NotifiesFreedesktop.hpp)
     list(APPEND QMPLAY2_SRC NotifiesFreedesktop.cpp)
-    if(BUILD_WITH_QT6)
-        qt6_add_dbus_interface(QMPLAY2_SRC org.freedesktop.Notifications.xml notifications_interface)
-    else()
-        qt5_add_dbus_interface(QMPLAY2_SRC org.freedesktop.Notifications.xml notifications_interface)
-    endif()
+    # Qt4 DBus interface generation
+    qt4_add_dbus_interface(QMPLAY2_SRC org.freedesktop.Notifications.xml notifications_interface)
     add_definitions(-DNOTIFIES_FREEDESKTOP)
 elseif(APPLE)
     list(APPEND QMPLAY2_HDR NotifiesMacOS.hpp)
@@ -233,22 +222,16 @@ elseif(APPLE)
 endif()
 
 if(USE_FREEDESKTOP_NOTIFICATIONS OR USE_DBUS_PM OR USE_MPRIS2)
-    set(DBUS ${QT_PREFIX}::DBus)
+    # Qt4 DBus support (QtDBus was already included in find_package if needed)
+    find_package(Qt4 COMPONENTS QtDBus)
+    if(QT_QTDBUS_FOUND)
+        set(DBUS ${QT_QTDBUS_LIBRARY})
+    endif()
 endif()
 
+# QML is not supported in Qt4 - USE_QML should be OFF
 if(USE_QML)
-    list(APPEND QMPLAY2_HDR
-        CommonJS.hpp
-        TreeWidgetJS.hpp
-        NetworkAccessJS.hpp
-    )
-    list(APPEND QMPLAY2_SRC
-        CommonJS.cpp
-        TreeWidgetJS.cpp
-        NetworkAccessJS.cpp
-    )
-    add_definitions(-DUSE_QML)
-    set(QML ${QT_PREFIX}::Qml)
+    message(FATAL_ERROR "QML is not supported in Qt4")
 endif()
 
 if(USE_YOUTUBEDL)
@@ -361,10 +344,7 @@ endif()
 
 target_link_libraries(${PROJECT_NAME}
     PUBLIC
-    ${QT_PREFIX}::Core
-    ${QT_PREFIX}::Gui
-    ${QT_PREFIX}::Widgets
-    ${QT_PREFIX}::Svg
+    ${QT_LIBRARIES}
     ${LIBAVFORMAT_LIBRARIES}
     ${LIBAVCODEC_LIBRARIES}
     ${LIBSWSCALE_LIBRARIES}
@@ -372,37 +352,26 @@ target_link_libraries(${PROJECT_NAME}
     ${LIBSWRESAMPLE_LIBRARIES}
     ${OPENGL_LIBS}
     ${DBUS}
+    ${QJSON4_LIBRARY}
     PRIVATE
-    ${QML}
     ${LIBQMPLAY2_LIBS}
 )
-if(USE_VULKAN)
-    target_link_libraries(${PROJECT_NAME}
-        PRIVATE
-        $<FILTER:$<TARGET_OBJECTS:QmVk>,EXCLUDE,.*\\.[gp]ch>
-    )
-    target_compile_definitions(${PROJECT_NAME}
-        PUBLIC
-        $<TARGET_PROPERTY:QmVk,INTERFACE_COMPILE_DEFINITIONS>
-    )
-    target_include_directories(${PROJECT_NAME}
-        PUBLIC
-        $<TARGET_PROPERTY:QmVk,INTERFACE_INCLUDE_DIRECTORIES>
-    )
-endif()
-if(BUILD_WITH_QT6)
-    target_link_libraries(${PROJECT_NAME}
-        PUBLIC
-        Qt6::Core5Compat # QTextCodec
-    )
-endif()
-
-if(USE_VULKAN AND NOT WIN32 AND NOT ANDROID)
-    target_link_libraries(${PROJECT_NAME}
-        PRIVATE
-        dl
-    )
-endif()
+# Vulkan support is disabled for Qt4/macOS 10.6.8
+# if(USE_VULKAN)
+#     target_link_libraries(${PROJECT_NAME}
+#         PRIVATE
+#         $<FILTER:$<TARGET_OBJECTS:QmVk>,EXCLUDE,.*\\.[gp]ch>
+#     )
+# endif()
+# Qt4 has QTextCodec built-in, no need for Core5Compat
+
+# Vulkan support disabled for Qt4/macOS 10.6.8
+# if(USE_VULKAN AND NOT WIN32 AND NOT ANDROID)
+#     target_link_libraries(${PROJECT_NAME}
+#         PRIVATE
+#         dl
+#     )
+# endif()
 
 macro(libqmplay2_set_target_params)
     target_link_libraries(${PROJECT_NAME}
diff --git a/src/qmplay2/ChapterProgramInfo.hpp b/src/qmplay2/ChapterProgramInfo.hpp
index e6042d56..728b5c44 100644
--- a/src/qmplay2/ChapterProgramInfo.hpp
+++ b/src/qmplay2/ChapterProgramInfo.hpp
@@ -18,6 +18,8 @@
 
 #pragma once
 
+#include <QPair>
+
 #include <QString>
 #include <QVector>
 
diff --git a/src/qmplay2/ColorButton.cpp b/src/qmplay2/ColorButton.cpp
index 55aedaf6..4976cbd8 100644
--- a/src/qmplay2/ColorButton.cpp
+++ b/src/qmplay2/ColorButton.cpp
@@ -26,7 +26,10 @@ ColorButton::ColorButton(QWidget *parent) :
 {
     setCursor(Qt::PointingHandCursor);
     setAttribute(Qt::WA_OpaquePaintEvent);
-    connect(this, &ColorButton::clicked, this, &ColorButton::openColorDialog);
+    connect(this, SIGNAL(clicked()), this, SLOT(openColorDialog()));
+}
+ColorButton::~ColorButton()
+{
 }
 
 void ColorButton::setAlphaAllowed(bool alpha)
@@ -43,7 +46,7 @@ void ColorButton::setColor(const QColor &color)
                .arg(m_color.red(), 2, 16, QChar('0'))
                .arg(m_color.green(), 2, 16, QChar('0'))
                .arg(m_color.blue(), 2, 16, QChar('0'))
-               .arg(m_alphaChannel ? QStringLiteral("%1").arg(m_color.alpha(), 2, 16, QChar('0')) : QString())
+               .arg(m_alphaChannel ? QString("%1").arg(m_color.alpha(), 2, 16, QChar('0')) : QString())
                .toUpper()
     );
     update();
diff --git a/src/qmplay2/ColorButton.hpp b/src/qmplay2/ColorButton.hpp
index feb1b943..ac2f8dae 100644
--- a/src/qmplay2/ColorButton.hpp
+++ b/src/qmplay2/ColorButton.hpp
@@ -22,11 +22,12 @@
 
 #include <QPushButton>
 
-class QMPLAY2SHAREDLIB_EXPORT ColorButton final : public QPushButton
+class QMPLAY2SHAREDLIB_EXPORT ColorButton : public QPushButton
 {
     Q_OBJECT
 public:
     ColorButton(QWidget *parent = nullptr);
+    ~ColorButton();
 
     void setAlphaAllowed(bool alpha);
 
@@ -37,9 +38,9 @@ public:
     }
 
 protected:
-    void paintEvent(QPaintEvent *) override;
+    void paintEvent(QPaintEvent *);
 
-private:
+private slots:
     void openColorDialog();
 
 signals:
diff --git a/src/qmplay2/CommonJS.cpp b/src/qmplay2/CommonJS.cpp
index 9c87026b..42b2c204 100644
--- a/src/qmplay2/CommonJS.cpp
+++ b/src/qmplay2/CommonJS.cpp
@@ -27,11 +27,9 @@ int CommonJS::insertNetworkReply(NetworkReply *networkReply)
     QMutexLocker locker(&m_networkReplyMutex);
     const auto id = ++m_networkReplyId;
     m_networkReplies[id] = networkReply;
+    m_networkReplyToId[networkReply] = id;
 
-    connect(networkReply, &NetworkReply::destroyed,
-            this, [=] {
-        removeNetworkReply(id);
-    });
+    connect(networkReply, SIGNAL(destroyed(QObject*)), this, SLOT(onNetworkReplyDestroyed()));
 
     return id;
 }
@@ -43,7 +41,12 @@ NetworkReply *CommonJS::getNetworkReply(const int id) const
 void CommonJS::removeNetworkReply(const int id)
 {
     QMutexLocker locker(&m_networkReplyMutex);
-    m_networkReplies.remove(id);
+    auto it = m_networkReplies.find(id);
+    if (it != m_networkReplies.end())
+    {
+        m_networkReplyToId.remove(it.value());
+        m_networkReplies.erase(it);
+    }
 }
 
 int CommonJS::insertIOController(IOController<> *ioCtrl)
@@ -97,12 +100,13 @@ int CommonJS::startTimer(const int ms, const bool singleShot, QJSValue onTimeout
     const auto id = ++m_timerId;
     m_timers[id] = timer;
 
-    connect(timer, &QTimer::timeout,
-            this, [=]() mutable {
-        onTimeout.call();
-        if (timer->isSingleShot())
-            stopTimer(id);
-    });
+    TimerData data;
+    data.id = id;
+    data.callback = onTimeout;
+    data.singleShot = singleShot;
+    m_timerData[timer] = data;
+
+    connect(timer, SIGNAL(timeout()), this, SLOT(onTimerTimeout()));
 
     return id;
 }
@@ -112,7 +116,9 @@ void CommonJS::stopTimer(const int id)
     auto it = m_timers.find(id);
     if (it != m_timers.end())
     {
-        delete it.value();
+        QTimer *timer = it.value();
+        m_timerData.remove(timer);
+        delete timer;
         m_timers.erase(it);
     }
 }
@@ -216,3 +222,39 @@ QString CommonJS::getNameForUrl(const QString &url)
 {
     return QMPlay2Core.getNameForUrl(url);
 }
+
+void CommonJS::onNetworkReplyDestroyed()
+{
+    QObject *obj = sender();
+    if (!obj)
+        return;
+
+    QMutexLocker locker(&m_networkReplyMutex);
+    auto it = m_networkReplyToId.find(obj);
+    if (it != m_networkReplyToId.end())
+    {
+        int id = it.value();
+        m_networkReplyToId.erase(it);
+        m_networkReplies.remove(id);
+    }
+}
+
+void CommonJS::onTimerTimeout()
+{
+    QTimer *timer = qobject_cast<QTimer*>(sender());
+    if (!timer)
+        return;
+
+    QMutexLocker locker(&m_timerMutex);
+    auto it = m_timerData.find(timer);
+    if (it != m_timerData.end())
+    {
+        TimerData data = it.value();
+        locker.unlock();
+
+        data.callback.call();
+
+        if (data.singleShot)
+            stopTimer(data.id);
+    }
+}
